#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "sequence.h"

static void
initialize_map (short *map) {
  int i;

  for (i = 0; i < 129; ++i) {
    map[i] = 20;
  }
  map['A'] = 0;  map['B'] = 20;  map['C'] = 1;  map['D'] = 2;
  map['E'] = 3;  map['F'] = 4;  map['G'] = 5;  map['H'] = 6;
  map['I'] = 7;  map['J'] = 20; map['K'] = 8;  map['L'] = 9;
  map['M'] = 10;  map['N'] = 11;  map['O'] = 20; map['P'] = 12;
  map['Q'] = 13;  map['R'] = 14;  map['S'] = 15;  map['T'] = 16;
  map['U'] = 20; map['V'] = 17;  map['W'] = 18;  map['X'] = 20;
  map['Y'] = 19;  map['Z'] = 20;  
  
  map['a'] = 0;  map['b'] = 20;  map['c'] = 1;  map['d'] = 2;
  map['e'] = 3;  map['f'] = 4;  map['g'] = 5;  map['h'] = 6;
  map['i'] = 7;  map['j'] = 20; map['k'] = 8;  map['l'] = 9;
  map['m'] = 10;  map['n'] = 11;  map['o'] = 20; map['p'] = 12; 
  map['q'] = 13;  map['r'] = 14;  map['s'] = 15;  map['t'] = 16;
  map['u'] = 20; map['v'] = 17;  map['w'] = 18;  map['x'] = 20;
  map['y'] = 19;  map['z'] = 20;

  /* map['*'] = 23;  map['-'] = 24; */
}


static short *
map_sequence (char *sequence_char, int length, short *map) {
  short *sequence_int;
  int i;

  sequence_int = (short *) calloc(length,sizeof(short));
  for (i = 0; i < length; ++i) {
    sequence_int[i] = map[(int) sequence_char[i]];
  }
  return sequence_int;
}


int
main (int argc, char *argv[]) {
  FILE *fasta_fp, *seq_fp, *desc_fp;
  char *fasta_file, *seq_file, *desc_file;
  char *sequence_char, *descript;
  int c = 0, length, descript_ptr = 0, descript_len;
  short map[129], *sequence_int;
  
  fasta_file = argv[1];
  seq_file = argv[2];
  desc_file = argv[3];
  fasta_fp = fopen(fasta_file,"r");
  seq_fp = fopen(seq_file,"wb");
  desc_fp = fopen(desc_file,"wb");

  initialize_map(map);
  while (!feof(fasta_fp) && !isspace(c = fgetc(fasta_fp))) {
    ungetc(c,fasta_fp);
    if ((sequence_char = Sequence_read(fasta_fp,&descript,&length))) {
      descript_len = strlen(descript);
      sequence_int = map_sequence(sequence_char,length,map);
      fwrite(&length,sizeof(int),1,seq_fp);
      fwrite(&descript_ptr,sizeof(long),1,seq_fp);
      fwrite(&descript_len,sizeof(int),1,seq_fp);
      descript_ptr += descript_len;
      fwrite(sequence_int,sizeof(short),length,seq_fp);
      fwrite(descript,sizeof(char),descript_len,desc_fp);
      free(descript);
      free(sequence_int);
      free(sequence_char);
    }
  }
  fclose(desc_fp);
  fclose(seq_fp);
  fclose(fasta_fp);
  return 0;
}

