#include "base.h"
#include "maxmin.h"
#include <stdio.h>
#include <stdlib.h>



static int
min_column (int **profile, int position) {
  int aa, min;

  min = profile[position][0];
  for (aa = 1; aa < NAT_AAS; aa++) {
    if (profile[position][aa] < min) {
      min = profile[position][aa];
    }
  }
  return min;
}

int
max_column (int **profile, int position) {
  int aa, max;
  
  max = profile[position][0];
  for (aa = 1; aa < NAT_AAS; aa++) {
    if (profile[position][aa] > max) {
      max = profile[position][aa];
    }
  }
  return max;
}

void
find_bounds (int *min_scores, int *max_scores, int **profile, int width) {
  int i;

  min_scores[0] = min_column(profile,0);
  max_scores[0] = max_column(profile,0);
  for (i = 1; i < width; i++) {
    min_scores[i] = min_scores[i-1] + min_column(profile,i);
    max_scores[i] = max_scores[i-1] + max_column(profile,i);
  }
}

void
print_floor (int **profile, int width) {
  int *floor, i;

  floor = (int *) calloc(width,sizeof(int));
  floor[width-1] = 0;
  for (i = width-2; i >= 0; --i) {
    floor[i] += floor[i+1] + max_column(profile,i+1);
  }
  for (i = 0; i < width; ++i) {
    printf("%d ",-floor[i]);
  }
  printf("\n");
}

void
print_floor_ordered (int **profile, int *ordering, int width) {
  int *floor, i, ii;

  floor = (int *) calloc(width,sizeof(int));
  floor[width-1] = 0;

  for (i = width-2; i >= 0; --i) {
    ii = ordering[i+1];
    floor[i] += floor[i+1] + max_column(profile,ii);
  }

  for (i = 0; i < width; ++i) {
    printf("%d ",-floor[i]);
  }
  printf("\n");

  free (floor);
}

